//
//  AppDelegate.m
//  FriendsMap
//
//  Created by Bernat Bombí Fernández on 15/11/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "AppDelegate.h"
#import "Reachability.h"

@implementation AppDelegate

@synthesize window = _window;

@synthesize locationManager, startingPoint, start, firstT, uid;

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    
    [[UIApplication sharedApplication] setStatusBarHidden:NO withAnimation:NO];

    [self.window makeKeyAndVisible];
        
    //configuro el locationManager
    self.locationManager = [[CLLocationManager alloc] init];
    locationManager.delegate = self;
    locationManager.desiredAccuracy = kCLLocationAccuracyBest;
    locationManager.distanceFilter = 500.0f;
    [locationManager startUpdatingLocation];
    
    self.start = [NSDate date];
    self.firstT = TRUE;
        
    return YES;

}

- (BOOL)reachable{
    
    //metodo que me dice si hay o no conexion a internet
    
    internetReachable = [Reachability reachabilityForInternetConnection];
    [internetReachable startNotifier];
    
    NetworkStatus internetStatus = [internetReachable currentReachabilityStatus];
    
    switch (internetStatus)
    {
        case NotReachable:
        {
            return FALSE;
            //no hi ha internet
            break;
        }
        default:
        {
            return TRUE;
            break;
        }
    }
}
							
#pragma mark -
#pragma mark CLLocationManagerDelegate Methods

- (void)locationManager:(CLLocationManager *)manager
    didUpdateToLocation:(CLLocation *)newLocation fromLocation:(CLLocation *)oldLocation{
        
    if(startingPoint == nil){
        self.startingPoint = newLocation;
    }
    
    
    //timestap es el tiempo entre que se ha actualizado la variable start y ahora
    NSTimeInterval timeInterval = [self.start timeIntervalSinceNow];
    
    //si es mas grande 120 segundos, o es la primra vez, entra 
    if(timeInterval < -120 || self.firstT == TRUE){
        
        //compuebo la uid
        
        NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
        
        NSString *usuari = [defaults objectForKey:@"uid"];
                
        uid = usuari;
        
        //set latitud y longitud
            
    NSString *latitudeString = [[NSString alloc] initWithFormat:@"%g", newLocation.coordinate.latitude];
    
    NSString *longitudeString = [[NSString alloc] initWithFormat:@"%g", newLocation.coordinate.longitude];
    
        if(self.firstT == TRUE){self.firstT = FALSE;} //si era true pasa a ser false
        self.start = [NSDate date]; // actualizo la ultima hora de actualizacion, para saber si son >120segs.
        
    //actualizo posicion en el server.
                
        if(self.uid){
            
            dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
                
                NSString *post =[NSString stringWithFormat:@"uid=%@&lat=%@&long=%@",self.uid, latitudeString, longitudeString];
                
                NSString *hostStr = @"http://friendsmap.bombi.cat/php/do_location.php?";
                
                hostStr = [hostStr stringByAppendingString:post];
                
                NSData *dataURL =  [NSData dataWithContentsOfURL: [ NSURL URLWithString: hostStr ]]; 
                
                NSString *serverOutput = [[NSString alloc] initWithData:dataURL encoding: NSASCIIStringEncoding];
                
                dispatch_sync(dispatch_get_main_queue(), ^{
                
                    NSLog(@"Actualizado / uid: %@ / lat: %@ / long: %@", self.uid, latitudeString, longitudeString);
                    
                });
            });
        }
        
    }
    
    
}

-(void)locationManager:(CLLocationManager *)manager didFailWithError:(NSError *)error{
    
    NSString *errorType = (error.code == kCLErrorDenied) ?
    @"Access Denied" : @"Unknown Error";
    
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error de localización" message:errorType delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil];
    
    [alert show];
    
}

@end
