//
//  SearchTableViewController.m
//  FriendsMap
//
//  Created by Bernat Bombí Fernández on 02/12/11.
//  Copyright (c) 2011 . All rights reserved.
//

#import "SearchTableViewController.h"
#import "YouViewController.h"
#import "ErrorViewController.h"
#import "AppDelegate.h"

@implementation SearchTableViewController

@synthesize uid, userFriends, userFriendsID, tableView, lastPath, searchBar, cercat, carregant, mainStoryboard;

- (void) viewDidAppear:(BOOL)animated{
    
    //compruebo internet
    AppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
    
    if(![appDelegate reachable]){
        
        ErrorViewController *errorViewController = (ErrorViewController*)[mainStoryboard 
                                                                          instantiateViewControllerWithIdentifier: @"errorView"];
        [self presentModalViewController: errorViewController animated: YES ];
    } 
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    
    [self.tableView deselectRowAtIndexPath:[self.tableView indexPathForSelectedRow] animated:YES];
    
    //si self.uid es diferente a los datos de usuario quiere decir que tiene que reiniciar los datos
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    if([defaults objectForKey:@"uid"] != self.uid){
        self.uid = [defaults objectForKey:@"uid"];
        searchBar.text = @"";
        self.userFriends = nil;
        self.userFriendsID = nil;
        [tableView reloadData];
    }
    
}

- (void) viewDidLoad{

    //defino el storyboard apropieado
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
        self.mainStoryboard = [UIStoryboard storyboardWithName:@"MainStoryboard_iPad" bundle: nil];
    }
    else {
        self.mainStoryboard = [UIStoryboard storyboardWithName:@"MainStoryboard_iPhone" bundle: nil];
    } 
    
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    self.uid = [defaults objectForKey:@"uid"];
    
    self.cercat = NO;
    
    self.navigationItem.title = @"Buscador"; 
            
}

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

- (void) searchBarTextDidBeginEditing:(UISearchBar *)theSearchBar{
    [searchBar setShowsCancelButton:YES animated:YES];    
}
- (void)searchBarCancelButtonClicked:(UISearchBar *)theSearchBar {
    
    searchBar.text=@"";
    
    [searchBar setShowsCancelButton:NO animated:YES];
    [searchBar resignFirstResponder];
    
    self.cercat = NO;
}

//implemento el què de quan es clicka el botó de cercar, que és cercar via php els resultats!
- (void)searchBarSearchButtonClicked:(UISearchBar *)searchBar {
    
    //cuando pulso el boton de search del uisearchbar
    
    //el array userfriends y userfriendsid pasa a estar vacio
    self.userFriends = nil;
    self.userFriendsID = nil;
    self.carregant = TRUE;
    [self.searchBar resignFirstResponder]; //escondo teclado
    [tableView reloadData]; //recargo datos de la tabla, para que quede vacia
    

    //asincronamente hago la peticion al servidor para que devuelva la lista de resultados, y los situo en los arrays 
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        
        NSString *textS = self.searchBar.text;
        
        NSString *post =[NSString stringWithFormat:@"uid=%@&w=n&s=%@",self.uid, textS];
        NSString *post2 =[NSString stringWithFormat:@"uid=%@&s=%@",self.uid, textS];
        NSString *hostStr = @"http://friendsmap.bombi.cat/php/plist/buscador.php?";
        hostStr = [hostStr stringByAppendingString:post];  
        NSString *hostStr2 = @"http://friendsmap.bombi.cat/php/plist/buscador.php?";
        hostStr2 = [hostStr2 stringByAppendingString:post2]; 
        NSURL *dataURL =  [NSURL URLWithString:[hostStr stringByAddingPercentEscapesUsingEncoding: NSUTF8StringEncoding]];
        NSURL *dataURL2 =  [NSURL URLWithString:[hostStr2 stringByAddingPercentEscapesUsingEncoding: NSUTF8StringEncoding]];
        NSArray *array = [[NSArray alloc] initWithContentsOfURL:dataURL];
        NSArray *array2 = [[NSArray alloc] initWithContentsOfURL:dataURL2];
        
        self.userFriends = array;   
        self.userFriendsID = array2;
        
        dispatch_sync(dispatch_get_main_queue(), ^{
            self.cercat = YES;
            [self.searchBar setShowsCancelButton:NO animated:YES]; //escondo el boton de cancelar
            self.carregant = FALSE;
            [tableView reloadData];//recargo datos de tableview, con los resultados   
        });
    });
    
}

#pragma mark - Table view data source

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    //dependiendo del numero de filas, muestro el total, o una donde hay el cargando
 
    if(cercat){
        if(self.carregant){
            return 1;
        }
        else{
        return [self.userFriends count];
        }
    }
    else if(self.carregant){
        return 1;
    }
    else{
        return 0;
    }
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    
    
    NSUInteger row = [indexPath row];
    
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [self.tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
    } 
    
    UIActivityIndicatorView *act = [[UIActivityIndicatorView alloc] initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleGray];
    [act startAnimating];
    
    if(cercat){
        if(self.carregant){
            cell.textLabel.text = @"Cargando...";
            cell.accessoryView = act;
        }
        else{
        cell.textLabel.text = [userFriends objectAtIndex:row];
            cell.accessoryView = nil;
        }
    }
    else if(self.carregant){
        cell.textLabel.text = @"Cargando...";
        cell.accessoryView = act;
    }
    else{
        cell.accessoryView = nil;
    }
    
    
    return cell;
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section{
    
    return nil;
    
}

- (UITableViewCellAccessoryType)tableView:(UITableView *)tableView accessoryTypeForRowWithIndexPath:(NSIndexPath *)indexPath{
    
    if([userFriends isEqualToArray:userFriendsID] || self.carregant){
        return UITableViewCellAccessoryNone;
    }
    else{
        return UITableViewCellAccessoryDisclosureIndicator;
    }
}

#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
        
    NSUInteger row = [indexPath row];
    
    YouViewController *youViewController = (YouViewController*)[mainStoryboard 
                                                                instantiateViewControllerWithIdentifier: @"youView"];
    //paso la id del usuario listado
    youViewController.fId = [self.userFriendsID objectAtIndex:row];
    
    UIBarButtonItem *newBackButton = [[UIBarButtonItem alloc] initWithTitle: @"Atrás" style: UIBarButtonItemStyleBordered target: nil action: nil];    
    [[self navigationItem] setBackBarButtonItem: newBackButton];
    
    if([userFriends isEqualToArray:userFriendsID] || [self.userFriends count] == 0){
        [self.tableView deselectRowAtIndexPath:indexPath animated:YES];
    }
    else{
        [self.navigationController pushViewController:youViewController animated:YES];
    }
    
    self.lastPath = indexPath;
    
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
        return (interfaceOrientation == UIInterfaceOrientationLandscapeLeft);
    }
    else {
        return (interfaceOrientation == UIInterfaceOrientationPortrait);
    }
}

@end