//
//  FriendsListViewController.m
//  FriendsMap
//
//  Created by Bernat Bombí Fernández on 30/11/11.
//  Copyright (c) 2011 . All rights reserved.
//

#import "FriendsListViewController.h"
#import "YouViewController.h"
#import "AppDelegate.h"
#import "ErrorViewController.h"

@implementation FriendsListViewController

@synthesize uid, userFriends, userFriendsID, lastPath, tableView, llistat, mainStoryboard;

- (void)viewWillAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    //deselecciono el la fila en indexpath:laspath, que es la ultima que he pulsado
    [self.tableView deselectRowAtIndexPath:lastPath animated:YES];
            
}

- (void)viewDidAppear:(BOOL)animated{    
    
    //si no hay internet muestro el error
    AppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
    
    if(![appDelegate reachable]){
        
        ErrorViewController *errorViewController = (ErrorViewController*)[mainStoryboard 
                                                                          instantiateViewControllerWithIdentifier: @"errorView"];
        [self presentModalViewController: errorViewController animated: YES ];
    }        
    
    //asincronamente guardo en arrays la lista de amigos, y sus id's. una vez hecho actualizo la tableView
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        
        NSString *post =[NSString stringWithFormat:@"uid=%@&w=n",self.uid];
        NSString *post2 =[NSString stringWithFormat:@"uid=%@",self.uid];
        NSString *hostStr = @"http://friendsmap.bombi.cat/php/plist/lista_amigos.php?";
        hostStr = [hostStr stringByAppendingString:post];  
        NSString *hostStr2 = @"http://friendsmap.bombi.cat/php/plist/lista_amigos.php?";
        hostStr2 = [hostStr stringByAppendingString:post2]; 
        NSURL *dataURL =  [NSURL URLWithString:hostStr];
        NSURL *dataURL2 =  [NSURL URLWithString:hostStr2];
        NSArray *array = [[NSArray alloc] initWithContentsOfURL:dataURL];
        NSArray *array2 = [[NSArray alloc] initWithContentsOfURL:dataURL2];
        
        self.userFriends = array;   
        self.userFriendsID = array2;
        
        dispatch_sync(dispatch_get_main_queue(), ^{
            [tableView reloadData];
            
        });
    });
}

-(void) viewDidLoad{
    //indico que no esta listado, defino el titulo, y defino el stroyboard correcto
    self.llistat = NO;
    self.navigationItem.title = @"Lista de amistades";
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
        self.mainStoryboard = [UIStoryboard storyboardWithName:@"MainStoryboard_iPad" bundle: nil];
    }
    else {
        self.mainStoryboard = [UIStoryboard storyboardWithName:@"MainStoryboard_iPhone" bundle: nil];
    } 
}

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{    
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
        return (interfaceOrientation == UIInterfaceOrientationLandscapeLeft);
    }
    else {
        return (interfaceOrientation == UIInterfaceOrientationPortrait);
    }
}

#pragma mark - Table view data source

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    //dependiendo del numero de filas, muestro el total, o una donde hay el cargando
    if([userFriends count] == 0){
        return 1;
    }
    else{
    return [self.userFriends count];
    }
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    //inserto las cell's
    NSUInteger row = [indexPath row];
    
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [self.tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
    }
    
    UIActivityIndicatorView *act = [[UIActivityIndicatorView alloc] initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleGray];
    [act startAnimating];
    
    //si la lista de amigos es cero, indico al usuario que esta cargando
    if([self.userFriends count] == 0){
        cell.textLabel.text = @"Cargando... ";
        cell.accessoryView = act;
    }
    //si no es 0, muestro los resultados
    else{
        cell.textLabel.text = [self.userFriends objectAtIndex:row];
        cell.accessoryView = nil;
    }
    return cell;
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section{
    return nil;
}

- (UITableViewCellAccessoryType)tableView:(UITableView *)tableView accessoryTypeForRowWithIndexPath:(NSIndexPath *)indexPath{
    
    //dependiendo del numero de filas muestro un accessorytype o no
    if([self.userFriends count] == 0 || [userFriends isEqualToArray:userFriendsID]){
        return UITableViewCellAccessoryNone;
    }
    else{
        return UITableViewCellAccessoryDisclosureIndicator;
    }
}


#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    
    NSUInteger row = [indexPath row];
    
    YouViewController *youViewController = (YouViewController*)[mainStoryboard 
                                                    instantiateViewControllerWithIdentifier: @"youView"];
    
    //paso el numero de ID del amigo al nuevo controlador
    youViewController.fId = [self.userFriendsID objectAtIndex:row];
    
    UIBarButtonItem *newBackButton = [[UIBarButtonItem alloc] initWithTitle: @"Atrás" style: UIBarButtonItemStyleBordered target: nil action: nil];    
    [[self navigationItem] setBackBarButtonItem: newBackButton];
    if([userFriends isEqualToArray:userFriendsID] || [self.userFriends count] == 0){
    //deselecciono
    [self.tableView deselectRowAtIndexPath:indexPath animated:YES];    
    }
    else{
    [self.navigationController pushViewController:youViewController animated:YES];
    }
    //guardo el ultimo path, para deseleccionarlo cuando vuelva a este controlador
    lastPath = indexPath;
    
}

@end
