//
//  LoginViewController.m
//  FriendsMap
//
//  Created by Bernat Bombí Fernández on 24/11/11.
//  Copyright (c) 2011 . All rights reserved.
//

#import "AppDelegate.h"
#import "LoginViewController.h"
#import "ErrorViewController.h"

@implementation LoginViewController

@synthesize mail, psw, btn, uid, userData, act, mainStoryboard, registrate, contrasenya;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    //dependiendo del UI_USER_INTERFACE_IDIOM selecciono un storyboard o otro
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
        self.mainStoryboard = [UIStoryboard storyboardWithName:@"MainStoryboard_iPad" bundle: nil];
    }
    else {
        self.mainStoryboard = [UIStoryboard storyboardWithName:@"MainStoryboard_iPhone" bundle: nil];
    } 
    
    act.hidden = TRUE; //escondo el activityindicator que solo muestor cuando estoy logando
    
    //color de fondo
    self.view.backgroundColor = [[UIColor alloc] initWithRed: 0.87450980392157 green: 1.0 blue: 0.16078431372549 alpha: 1.0];
    
    //selecciono el textfield por defecto
    [mail becomeFirstResponder];    
    
    //al pulsar ok en el textfield de psw hago la accion de logar
    [self.psw addTarget:self action:@selector(loginMe:) forControlEvents:UIControlEventEditingDidEndOnExit];
    
    //defino el boton de logar
    [btn setTitle:@"Acceder" forState:UIControlStateNormal];
    btn.backgroundColor = [UIColor clearColor];    
    UIImage* button = [UIImage imageNamed:@"button.png"]; 
    UIImage *newImage = [button stretchableImageWithLeftCapWidth:button.size.width/2 topCapHeight:button.size.height/2];
    [btn setBackgroundImage:newImage forState:UIControlStateNormal];
    [btn setTitleColor:[UIColor darkTextColor] forState:UIControlStateNormal];
    [btn setTitleShadowColor:[UIColor whiteColor] forState:UIControlStateNormal];
    [btn setTitleShadowColor:[UIColor blackColor] forState:UIControlStateHighlighted];
    
    //si no hay internet muestro el viewcontroller de error
    AppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
    
    if(![appDelegate reachable]){
        
        ErrorViewController *errorViewController = (ErrorViewController*)[mainStoryboard 
                                                                          instantiateViewControllerWithIdentifier: @"errorView"];
        [self presentModalViewController: errorViewController animated: YES ];
    }
   
}

//cuando pulso siguiente en textfield de mail, voy hacia psw
- (IBAction)textFieldDoneEditing:(id)sender
{
    [psw becomeFirstResponder];
}

//cuando pulso los botones de "registrate" y "no recuerdo la contraseña" abro safari con las siguientes url's
- (IBAction)registrate:(id)sender{
    NSURL *url = [ [ NSURL alloc ] initWithString: @"http://friendsmap.bombi.cat/sign_up.php" ];
    [[UIApplication sharedApplication] openURL:url];
}

- (IBAction)recuerdame:(id)sender{
    NSURL *url = [ [ NSURL alloc ] initWithString: @"http://friendsmap.bombi.cat/remember.php" ];
    [[UIApplication sharedApplication] openURL:url];
}

- (void)viewDidUnload
{
    [super viewDidUnload];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{    
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
        return (interfaceOrientation == UIInterfaceOrientationLandscapeLeft);
    }
    else {
        return (interfaceOrientation == UIInterfaceOrientationPortrait);
    }
}


//metodo de login
- (IBAction) loginMe: (id) sender
{
   //desactivo mail i psw
    [mail setUserInteractionEnabled:NO];
    [psw setUserInteractionEnabled:NO];
    
    //compruebo que haya internet
    AppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
    
    if(![appDelegate reachable]){
        
        ErrorViewController *errorViewController = (ErrorViewController*)[mainStoryboard 
                                                                          instantiateViewControllerWithIdentifier: @"errorView"];
        
        [self presentModalViewController: errorViewController animated: YES ];
    }
    else{ //si hay internet
        
        //muestro el activityindicator, hago que se mueva, y defino el titulo del boton como "".
        act.hidden = FALSE;
        [self.act startAnimating];
        [btn setTitle:@"" forState:UIControlStateNormal];
        
        //asincronamente        
        dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
            
            //hago la peticion al servidor
            
            NSString *post =[NSString stringWithFormat:@"mail=%@&psw=%@",mail.text, psw.text];
            
            NSString *hostStr = @"http://friendsmap.bombi.cat/php/do_log_in.php?";
            
            hostStr = [hostStr stringByAppendingString:post];
            
            NSData *dataURL =  [NSData dataWithContentsOfURL: [ NSURL URLWithString: hostStr ]]; 
            
            NSString *serverOutput = [[NSString alloc] initWithData:dataURL encoding: NSASCIIStringEncoding];
            
            dispatch_sync(dispatch_get_main_queue(), ^{
                
                //una vez recibida, compruebo si ha ido todo bien, si la clave es correcta,
                
                if([serverOutput isEqualToString:@"no"] || serverOutput == (id)[NSNull null] || serverOutput.length == 0){ //si no es correcta, muestro una alerta
                    
                    UIAlertView *alertsuccess = [[UIAlertView alloc] initWithTitle:@"Acceso denegado" message:@"El correo electrónico o la contraseña son incorrectos. "
                                                                          delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
                    [alertsuccess show];
                    act.hidden = TRUE;
                    [self.act stopAnimating];
                    [btn setTitle:@"Acceder" forState:UIControlStateNormal];
                    [mail setUserInteractionEnabled:YES];
                    [psw setUserInteractionEnabled:YES];
                    
                }
                else { //si es correcta
                    
                    // escondo teclados
                    [mail resignFirstResponder];
                    [psw resignFirstResponder];
                    
                    //asincronamente recojo los datos del usuario, y los guardo en NSUserDefaults
                    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
                        
                        NSString *post =[NSString stringWithFormat:@"uid=%@",serverOutput];
                        
                        NSString *hostStr = @"http://friendsmap.bombi.cat/php/plist/yo.php?";
                        
                        hostStr = [hostStr stringByAppendingString:post];
                        
                        NSURL *dataURL =  [NSURL URLWithString:hostStr];
                        
                        NSArray *array = [[NSArray alloc] initWithContentsOfURL:dataURL];
                        
                        self.userData = array;
                        
                        dispatch_sync(dispatch_get_main_queue(), ^{
                            [self.act stopAnimating]; // for example
                            act.hidden = TRUE;
                            
                            // deso les dades
                            NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
                            
                            NSString *idU = [userData objectAtIndex:0];
                            NSString *nomU = [userData objectAtIndex:1];
                            NSString *cityU = [userData objectAtIndex:2];
                            NSString *mailU = [userData objectAtIndex:3];
                            
                            //deso les dades a NSUserDefaults
                            [defaults setObject:idU forKey:@"uid"];
                            [defaults setObject:nomU forKey:@"nom"];
                            [defaults setObject:cityU forKey:@"city"];
                            [defaults setObject:mailU forKey:@"mail"];
                            
                            [defaults synchronize];
                                                        
                            [btn setTitle:@"Acceder" forState:UIControlStateNormal];
                            
                            //dimissmodal y accedo a la parte restringida de la app
                            [self dismissModalViewControllerAnimated:YES];
                            [mail setUserInteractionEnabled:YES];
                            [psw setUserInteractionEnabled:YES];
                            
                        });
                    });
                }
            });
        });
    }
}



@end
