//
//  WebViewController.m
//  FriendsMap
//
//  Created by Bernat Bombí Fernández on 23/11/11.
//  Copyright (c) 2011 . All rights reserved.
//

#import "WebViewController.h"
#import "AppDelegate.h"
#import "ErrorViewController.h"

@implementation WebViewController

@synthesize URL, webView, viewTitle, mainStoryboard;

- (void) viewDidAppear:(BOOL)animated{
    
    //si no hay internet, muestro el viewcontroller de error    
    AppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
    
    if(![appDelegate reachable]){
        
        ErrorViewController *errorViewController = (ErrorViewController*)[mainStoryboard 
                                                                          instantiateViewControllerWithIdentifier: @"errorView"];
        [self presentModalViewController: errorViewController animated: YES ];
    }    

}

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    //nueva nsurlrequest dependiendo de self.url
    NSURLRequest *urlRequest = [NSURLRequest requestWithURL:self.URL];
    [self.webView loadRequest:urlRequest];
    
    //cambio el titulo dependiendo de self.viewTitle
    self.navigationItem.title = self.viewTitle;
    
    //set color, el verde
    webView.backgroundColor = [UIColor colorWithRed:0.82352941176471 green:1 blue:0 alpha:1];
    
    //elimino las sombras superior y inferior de los webviews
    for(UIView *wview in [[[webView subviews] objectAtIndex:0] subviews]) { 
        if([wview isKindOfClass:[UIImageView class]]) { wview.hidden = YES; } 
    }
    
    webView.delegate = self;
        
    //creo un activityindicator para asignarlo mientras se este cargando la web
    UIActivityIndicatorView *activityIndicator = [[UIActivityIndicatorView alloc] initWithFrame:CGRectMake(0, 0, 20, 20)];
    [activityIndicator startAnimating];
    UIBarButtonItem *activityItem = [[UIBarButtonItem alloc] initWithCustomView:activityIndicator];
    self.navigationItem.rightBarButtonItem = activityItem;
    
    //dependiendo de ui_user_interface_idiom defino un storyboard o otro
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
        self.mainStoryboard = [UIStoryboard storyboardWithName:@"MainStoryboard_iPad" bundle: nil];
    }
    else {
        self.mainStoryboard = [UIStoryboard storyboardWithName:@"MainStoryboard_iPhone" bundle: nil];
    } 
}
- (void)webViewDidFinishLoad:(UIWebView *)webView{
	//elimino el activityindicator de navigation bar right
    self.navigationItem.rightBarButtonItem = nil;
}

- (void)viewDidUnload
{
    [super viewDidUnload];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{    
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
        return (interfaceOrientation == UIInterfaceOrientationLandscapeLeft);
    }
    else {
        return (interfaceOrientation == UIInterfaceOrientationPortrait);
    }
}

@end
