//
//  YouViewController.m
//  FriendsMap
//
//  Created by Bernat Bombí Fernández on 01/12/11.
//  Copyright (c) 2011 . All rights reserved.
//

#import "YouViewController.h"
#import "AppDelegate.h"
#import "ErrorViewController.h"
#import "MeTableViewController.h"
#import "SearchNavController.h"
#import "DetailMapViewController.h"

@implementation YouViewController

@synthesize fId, uid, userData, post, tableView, status, llistat, estatRelacio, mainStoryboard, btnDes;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

#pragma mark - View lifecycle

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidLoad];
    
    //si no hay internet muestro error
    AppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
    
    if(![appDelegate reachable]){
        
        ErrorViewController *errorViewController = (ErrorViewController*)[mainStoryboard 
                                                                          instantiateViewControllerWithIdentifier: @"errorView"];
        [self presentModalViewController: errorViewController animated: YES ];
    }    
    //asincronamente recojo los datos del usuario
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        
        NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
        self.uid = [defaults objectForKey:@"uid"];
            
        post =[NSString stringWithFormat:@"uid=%@&uid2=%@",self.fId, self.uid];    
        
        NSString *hostStr = @"http://friendsmap.bombi.cat/php/plist/you.php?";
        hostStr = [hostStr stringByAppendingString:post];  
        NSURL *dataURL =  [NSURL URLWithString:hostStr];
        NSArray *array = [[NSArray alloc] initWithContentsOfURL:dataURL];
        
        self.userData = array; 
        
        self.status = [userData objectAtIndex:4];
                
        dispatch_sync(dispatch_get_main_queue(), ^{
            
            //una vez recogidos creo un boton, para eliminar amistad, aceptar amistad / solicitar amistad
            self.btnDes = [UIButton buttonWithType:UIButtonTypeRoundedRect];
            self.btnDes.backgroundColor = [UIColor clearColor];    
            UIImage* redButton = [UIImage imageNamed:@"glass.png"]; 
            UIImage *newImage = [redButton stretchableImageWithLeftCapWidth:redButton.size.width/2 topCapHeight:redButton.size.height/2];
            [self.btnDes setBackgroundImage:newImage forState:UIControlStateNormal];
            [self.btnDes setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
            [self.btnDes addTarget:self action:@selector(doAmistad:) forControlEvents:UIControlEventTouchUpInside];
            
            //lo añado en un footerView
            if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
                self.btnDes.frame = CGRectMake(0, 0, 935, 40);
                UIView *footerView = [[UIView alloc] initWithFrame:CGRectMake(45, 0, 935, 60)];
                [footerView addSubview:self.btnDes];
                tableView.tableFooterView = footerView;
            }
            else {
                btnDes.frame = CGRectMake(0, 0, 300, 40);
                UIView *footerView = [[UIView alloc] initWithFrame:CGRectMake(10, 0, 300, 60)];
                [footerView addSubview:btnDes];       
                tableView.tableFooterView = footerView;
            }
            
            //dependiendo de la relacion entre usuarios pongo un titulo o otro al boton, y defino la var estatRelacio como una cosa o otra
            if([self.status isEqualToString: @"1"]){
                [btnDes setTitle:@"Eliminar amistad" forState:UIControlStateNormal];
                self.estatRelacio = @"amics";
            }
            else if([self.status isEqualToString: @"0"]){
                if([[userData objectAtIndex:5] isEqualToString:self.uid]){
                    [btnDes setTitle:@"Solicitud de amistad enviada" forState:UIControlStateNormal]; 
                    self.estatRelacio = @"solenviada";
                    [btnDes setEnabled:NO]; //desactivo el boton
                    [btnDes setTitleColor:[UIColor grayColor] forState:UIControlStateNormal];    
                }
                else{
                    [btnDes setTitle:@"Aceptar solicitud de amistad" forState:UIControlStateNormal];
                    self.estatRelacio = @"solrebuda";
                }
                
            }
            else{
                [btnDes setTitle:@"Solicitar amistad" forState:UIControlStateNormal];
                self.estatRelacio = @"cap";
            }
            
            //recargo datos de la tableView
            [tableView reloadData];
            
        });
    });
    
}

- (void)viewDidLoad{    
    self.navigationItem.title = @"Gente";
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
        self.mainStoryboard = [UIStoryboard storyboardWithName:@"MainStoryboard_iPad" bundle: nil];
    }
    else {
        self.mainStoryboard = [UIStoryboard storyboardWithName:@"MainStoryboard_iPhone" bundle: nil];
    } 
}


- (void)viewDidUnload
{
    [super viewDidUnload];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{    
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
        return (interfaceOrientation == UIInterfaceOrientationLandscapeLeft);
    }
    else {
        return (interfaceOrientation == UIInterfaceOrientationPortrait);
    }
}

#pragma mark - Table view data source

//mismo funcionamiento que FriendListViewController
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    if([userData count] == 0){
        return 1;
    }
    else{
        if([self.status isEqualToString: @"1"]){
            return 2;
        }
        else return 1;
    }
}


- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    if([userData count] == 0){
        return 1;
    }
    else{
        if(section == 0){
            if([self.status isEqualToString: @"1"]){
                return 2;
            }
            else{
                return 1;
            }
        }
    else return 1;
    }
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{    
    
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [self.tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
    }
    
    UIActivityIndicatorView *act = [[UIActivityIndicatorView alloc] initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleGray];
    [act startAnimating];
    
    if([self.userData count] == 0){
        cell.textLabel.text = @"Cargando... ";
        cell.accessoryView = act; 
    }
    else{    
    if(indexPath.section == 0){
        if(indexPath.row == 0){
            cell.userInteractionEnabled = NO;
            cell.textLabel.text = [userData objectAtIndex:2];
        }
        if([self.status isEqualToString: @"1"]){
        if(indexPath.row == 1){
            cell.textLabel.text = [userData objectAtIndex:3];
        }
        }
    }
    if(indexPath.section == 1){
        if(indexPath.row == 0){
            cell.textLabel.text = @"Ver posición";
        }
    }
        cell.accessoryView = nil;
    }
    return cell;
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section{
    
    if([userData count] == 0){
        return nil;
    }
    else{
    if (section==0) {
        return [userData objectAtIndex:1];
    } else {
        return nil;
    }
    }
    
}

- (UITableViewCellAccessoryType)tableView:(UITableView *)tableView accessoryTypeForRowWithIndexPath:(NSIndexPath *)indexPath{
    
    if (indexPath.section == 0)
        if(indexPath.row == 0)
            return UITableViewCellAccessoryNone;
    
    if([self.userData count] == 0){
        return UITableViewCellAccessoryNone;
    }
    
    return UITableViewCellAccessoryDisclosureIndicator;
}


#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    
    //si pulso el correo electrónico del usuario (section 0, row 1) abre la app de mail
    if(indexPath.section == 0)
        if(indexPath.row == 1)
        {
            NSString *mail = [userData objectAtIndex:3];
            NSString *path = [NSString stringWithFormat:@"mailto:%@", mail];
            NSURL *url = [NSURL URLWithString:path];
            [[UIApplication sharedApplication] openURL:url];
        }
    //si pulso en "ver posicion" me abre DetailMapViewController con la ultima posicion del usuario
    if(indexPath.section == 1)
        if(indexPath.row == 0)
        {
            DetailMapViewController *detailMapViewController = (DetailMapViewController*)[mainStoryboard 
                                                                                                instantiateViewControllerWithIdentifier: @"detailMap"];
            // Pass the selected object to the new view controller.
            detailMapViewController.fid = self.fId;
            UIBarButtonItem *newBackButton = [[UIBarButtonItem alloc] initWithTitle: @"Atrás" style: UIBarButtonItemStyleBordered target: nil action: nil];    
            [[self navigationItem] setBackBarButtonItem: newBackButton];
            [self.navigationController pushViewController:detailMapViewController animated:YES];
        }
    
    //descelecciona la fila
    [self.tableView deselectRowAtIndexPath:indexPath animated:YES];
    
}

- (IBAction)doAmistad:(id)sender{
    
    //cuando pulso el boton, hago amistad, elimino amistad, o solicito amistad
    if(self.estatRelacio == @"amics"){
        UIAlertView *alert = [[UIAlertView alloc]
                              initWithTitle:@"Seguro que quieres eliminar la amistad?"
                              message:nil
                              delegate:self
                              cancelButtonTitle:@"No"
                              otherButtonTitles:@"Si, elimina", nil];
        [alert show];
    }
    else if(self.estatRelacio == @"solrebuda"){
        UIAlertView *alert = [[UIAlertView alloc]
                              initWithTitle:@"Seguro que quieres aceptar la solicitud de amistad?"
                              message:nil
                              delegate:self
                              cancelButtonTitle:@"No"
                              otherButtonTitles:@"Si, acepta", nil];
        [alert show];
    }
    else if(self.estatRelacio == @"cap"){
        UIAlertView *alert = [[UIAlertView alloc]
                              initWithTitle:@"Seguro que quieres enviar la petición de amistad?"
                              message:nil
                              delegate:self
                              cancelButtonTitle:@"No"
                              otherButtonTitles:@"Si, envia", nil];
        [alert show];
    }
    else{
        //res de res
    }
    
    //si el usuario pulsa "sí", me lleva al siguiente metodo:
}

- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex{
    
    //hago lo que pide el usuario, asincronamente. una vez completado recargo el view
    
    if (buttonIndex == 1) {
        
        [self.btnDes setEnabled:NO]; //desactivo el boton
        [self.btnDes setTitleColor:[UIColor grayColor] forState:UIControlStateNormal];
        [self.btnDes setTitle:@"Un momento..." forState:UIControlStateNormal];
        
        dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
            
            NSString *postT =[NSString stringWithFormat:@"uid=%@&uid2=%@&que=%@",self.uid, self.fId, self.estatRelacio];
            
            NSString *hostStr = @"http://friendsmap.bombi.cat/php/do_relations.php?";
            
            hostStr = [hostStr stringByAppendingString:postT];
            
            NSData *dataURL =  [NSData dataWithContentsOfURL: [ NSURL URLWithString: hostStr ]]; 
            
            NSString *serverOutput = [[NSString alloc] initWithData:dataURL encoding: NSASCIIStringEncoding];
            
            dispatch_sync(dispatch_get_main_queue(), ^{
                                
                if([serverOutput isEqualToString:@"ok"]){
                
                    //al cambiar la relacion, actualizo el view para cargar los nuevos datos diposnibles    
                    [self viewDidAppear:YES];
                }
                else{
                    UIAlertView *alert = [[UIAlertView alloc]
                                          initWithTitle:@"Ha ocurrido un error."
                                          message:nil
                                          delegate:self
                                          cancelButtonTitle:@"OK"
                                          otherButtonTitles:nil, nil];
                    [alert show];
                }
            });
        });
    }
}

@end
